-- A counter of Level II updates MarketUpdateTest.lua
CLASS_CODE_FUT="SPBFUT"       	-- FUTURES class
SEC_CODE_FUT_FOR_OPEN="SiU6"  	-- Security (futures) code
running = true                	-- Script operation flag
local logfile;
local ticks=0;
local start_ticks=5;  	-- Required number of ticks per seconds in order to start counting time
local lastupdate;		-- The time of the last order book update
-- Arrays to store ticks, 5000 is more than enough for 1 minute
local ticks={};        	-- Tick numbers
local ticktimes={};  	-- Tick time in milliseconds
local tickcounter=0;	-- Tick counter
local startsession=0;	-- Trading session start time
local firsttick=0;		-- The number of the first tick in the order book
local prevupdate=0;     -- Time of the last order book update
-- Order book (Level II) running
local marketstarted=false;
-- An additional parameter for calculating the index in the ticktimes[] array
local shift;
-- This is the main function if the script, runs automatically; the script runs until the function completes 
function main()
	-- Tries to open a file in the "read/write" mode
	logfile = io.open(getScriptPath().."\\MarketUpdateTest_log.txt","a+");
	-- If the file does not exist
	if logfile == nil then 
		-- Creates a file in the "write" mode
		logfile = io.open(getScriptPath().."\\MarketUpdateTest_log.txt","w"); 
		-- Closes the file
		logfile:close();
		-- Opens an existing file and the "read/write" mode
		logfile = io.open(getScriptPath().."\\MarketUpdateTest_log.txt","r+");
	end;
	shift=start_ticks-1;
	Print("MarketUpdateTest.lua starting...");
	message("MarketUpdateTest.lua starting");
	Print("CLASS_CODE_FUT="..CLASS_CODE_FUT..":    SEC_CODE_FUT_FOR_OPEN="..SEC_CODE_FUT_FOR_OPEN);
	-- The flag is only switched when the script is stopped by a user
    while running do
		--message(os.date()) -- shows date ant time once in 15 seconds
        sleep(5000)
    end
	logfile:flush();
	logfile:close();
end

-- Called with each update of the order book
function OnQuote(class, sec ) 
	--Print("OnQuote: "..class.."  "..sec);
	if(running==false) then
		return
	end

	-- Track only the required instrument
	if class==CLASS_CODE_FUT and sec==SEC_CODE_FUT_FOR_OPEN then
		-- Order book update time in seconds since the launch of the Quik terminal (to millisecond)
		lastupdate=os.clock();
		-- Counting ticks
		tickcounter=tickcounter+1;
		ticks[tickcounter]=tickcounter;
		ticktimes[tickcounter]=lastupdate;
        --Print(string.format("ticks #%d  os.clock()=%.3f",tickcounter,lastupdate));
		if marketstarted==false then
			Print(string.format("%d ticks (+%d ms)",tickcounter,(lastupdate-prevupdate)*1000));
			prevupdate=lastupdate;
			if tickcounter>=start_ticks then
				-- If start_ticks received in less than a second 
				if lastupdate-ticktimes[tickcounter-shift]<1 then
					startsession=ticktimes[tickcounter-shift];
					firsttick=tickcounter-shift;
					marketstarted=true;
					Print("Time counting starts from tick #"..firsttick);				
				end
			end
		else
			local counted_ticks=tickcounter-firsttick+1;
			seconds=lastupdate-startsession;		
			info=string.format("%d ticks for %.1f seconds:  %.1f ticks/sec",
								counted_ticks,seconds,counted_ticks/seconds);
			message(info);
			info=info..string.format(" (+%d ms)",(lastupdate-prevupdate)*1000);
			Print(info);		
			prevupdate=lastupdate;
			-- The script will stop in a minute
			if seconds>30 then
				running=false;
			end			
		end
		
	end	
	-- If there are many ticks, stop the script
	if tickcounter>1000 then
		running=false;
	end

end

-- The event of script stop by user
function OnStop(s)
	fulltime=lastupdate-start;
	info=string.format("MarketUpdateTest.lua finished, %d updates of Market for %.1f seconds = %.1f ticks/sec",
						ticks,fulltime,ticks/fulltime);
	Print(info);
	message(info);
	-- Setting the flag to 'Off'
	running = false;
	return 3000 -- Setting timeout of 3 seconds
end



-- Adds messages to a log file
function Print(line)
	if (logfile~=nil) then
	    timestamp=os.date("%Y.%m.%d %H:%M:%S ");
		logfile:write(timestamp.."\t"..line.."\n");
	end
end